package cn.com.qmth.stmms.biz.basic.service.impl;

import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.ConcurrentHashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import cn.com.qmth.stmms.biz.basic.dao.RolePrivilegeDao;
import cn.com.qmth.stmms.biz.basic.model.RolePrivilege;
import cn.com.qmth.stmms.biz.basic.service.RolePrivilegeService;
import cn.com.qmth.stmms.biz.common.BaseQueryService;
import cn.com.qmth.stmms.common.enums.Role;

@Service("rolePrivilegeService")
public class RolePrivilegeServiceImpl extends BaseQueryService<RolePrivilege> implements RolePrivilegeService {
	private static Map<String, Set<String>> privilegeCodes = new ConcurrentHashMap<>();
	private static Object lock = new Object();
	@Autowired
	private RolePrivilegeDao rolePrivilegeDao;

	@Override
	public Set<String> getRoleCodes(Integer schoolId, Role role) {
		String key = schoolId + "-" + role.name();
		Set<String> set = privilegeCodes.get(key);
		if (set == null) {
			synchronized (lock) {
				set = privilegeCodes.get(key);
				if (set == null) {
					set = new HashSet<>();
					List<RolePrivilege> list = rolePrivilegeDao.findBySchoolIdAndRoleCodeAndEnable(schoolId, role,
							true);
					if (list != null) {
						for (RolePrivilege r : list) {
							set.add(r.getPrivilegeCode());
						}
					}
					privilegeCodes.put(key, set);
				}
			}
		}
		return set;
	}
}
